diff -ruN i4b.org/FreeBSD/CONFIG i4b/FreeBSD/CONFIG
--- i4b.org/FreeBSD/CONFIG	Tue Jun  1 14:51:17 1999
+++ i4b/FreeBSD/CONFIG	Thu Jun  3 19:15:30 1999
@@ -78,6 +78,10 @@
 # options "AVM_PNP"  
 # device isic0 at isa? port ? net irq ? vector isicintr
 #
+# Siemens I-Surf 2.0 
+# options "SIEMENS_ISURF2"  
+# device isic0 at isa? port ? net irq ? vector isicintr
+#
 # PCI-Cards:
 # ----------
 #
diff -ruN i4b.org/FreeBSD/files.i386.cat i4b/FreeBSD/files.i386.cat
--- i4b.org/FreeBSD/files.i386.cat	Wed Feb 17 15:31:41 1999
+++ i4b/FreeBSD/files.i386.cat	Thu Jun  3 19:20:36 1999
@@ -16,6 +16,7 @@
 i4b/layer1/i4b_avm_a1.c		optional	isic	device-driver
 i4b/layer1/i4b_avm_fritz_pci.c	optional	isic	device-driver
 i4b/layer1/i4b_avm_fritz_pcmcia.c optional	isic	device-driver
+i4b/layer1/i4b_avm_fritz_pnp.c	optional	isic	device-driver
 i4b/layer1/i4b_usr_sti.c	optional	isic	device-driver
 i4b/layer1/i4b_itk_ix1.c	optional	isic	device-driver
 i4b/layer1/i4b_drn_ngo.c	optional	isic	device-driver
@@ -23,3 +24,4 @@
 i4b/layer1/i4b_dynalink.c	optional	isic	device-driver
 i4b/layer1/i4b_elsa_qs1i.c	optional	isic	device-driver
 i4b/layer1/i4b_elsa_qs1p.c	optional	isic	device-driver
+i4b/layer1/i4b_siemens_isurf.c	optional	isic	device-driver
diff -ruN i4b.org/FreeBSD/options.i386.cat i4b/FreeBSD/options.i386.cat
--- i4b.org/FreeBSD/options.i386.cat	Tue Mar 16 15:57:53 1999
+++ i4b/FreeBSD/options.i386.cat	Thu Jun  3 19:21:52 1999
@@ -17,6 +17,8 @@
 SEDLBAUER		opt_i4b.h
 DYNALINK		opt_i4b.h
 ELSA_QS1ISA		opt_i4b.h
+AVM_PNP			opt_i4b.h
+SIEMENS_ISURF2		opt_i4b.h
 # -------------------------------
 # isdn4bsd: passive PCI cards
 # -------------------------------
diff -ruN i4b.org/README i4b/README
--- i4b.org/README	Tue Jun  1 17:05:42 1999
+++ i4b/README	Thu Jun  3 19:14:40 1999
@@ -212,6 +212,7 @@
   Sedlbauer Win Speed	YES	YES	???	???	(Note 9)
   Teles S0 PnP		???	???	???	???	(Note 5)
   3Com USR PnP internal DEV	NO	NO	NO	(under development)
+  Siemens I-Surf 2.0	YES	NO	NO	NO	(Note 15)
 
   Type (passive, PCI)	FreeBSD NetBSD OpenBSD BSD/OS	Notes
   --------------------- -------	------ ------- ------	-----------------------
@@ -240,8 +241,8 @@
 
 
 Note 1:	The driver for the Fritz!Card PnP was developed by Udo Schweigert 
-	(ust@cert.siemens.de) and is currently in an alpha state. Please
-	contact Udo in case of trouble.
+	(ust@cert.siemens.de) who develops under FreeBSD only.
+	Please contact Udo in case of trouble.
 
 Note 2:	FreeBSD
 		This is a PnP card. To run it under FreeBSD, you need
@@ -303,6 +304,10 @@
 Note 14: This driver was developed by Gary Jennejohn who develops under
 	FreeBSD only. In case of problems with this driver, please contact
 	him directly at garyj@muc.de.
+
+Note 15: The driver for the Siemens I-Surf 2.0 was developed by Udo Schweigert 
+	(ust@cert.siemens.de) who develops under FreeBSD only.
+	Please contact Udo in case of trouble.
 
 
 5. Where do i find documentation for isdn4bsd ?
diff -ruN i4b.org/isdnd/support.c i4b/isdnd/support.c
--- i4b.org/isdnd/support.c	Tue Jun  1 14:51:17 1999
+++ i4b/isdnd/support.c	Thu Jun  3 19:23:24 1999
@@ -601,7 +601,8 @@
  		"ITK ix1 micro",
 		"AVM Fritz!Card PCI",
 		"ELSA PCC-16",
-		"AVM Fritz!Card PnP"		
+		"AVM Fritz!Card PnP",		
+		"Siemens I-Surf 2.0 PnP"		
 	};
 
 	static char *daic_card[] = {
diff -ruN i4b.org/layer1/i4b_avm_fritz_pnp.c i4b/layer1/i4b_avm_fritz_pnp.c
--- i4b.org/layer1/i4b_avm_fritz_pnp.c	Tue Jun  1 17:17:49 1999
+++ i4b/layer1/i4b_avm_fritz_pnp.c	Thu Jun  3 19:51:38 1999
@@ -32,15 +32,13 @@
  *   a lot of code was borrowed from i4b_bchan.c and i4b_hscx.c
  *   based on AVM Fritz!PCI driver by Gary Jennejohn
  *---------------------------------------------------------------------------
- *   This code has currently to be considered ALPHA!
- *---------------------------------------------------------------------------
  *
  *	Fritz!Card PnP specific routines for isic driver
  *	------------------------------------------------
  *
- *	$Id: i4b_avm_fritz_pnp.c,v 1.1 1999/06/01 15:17:49 hm Exp $
+ *	$Id: i4b_avm_fritz_pnp.c,v 1.11 1999/06/03 17:49:38 ust Exp $
  *
- *      last edit-date: [Tue  1 Jun 08:49:35 CEST 1999]
+ *      last edit-date: [Thu  3 Jun 19:45:45 CEST 1999]
  *
  *---------------------------------------------------------------------------*/
 
@@ -325,9 +323,6 @@
 	}
 	/* must be the ISAC */
 	reg_bank = (offset > MAX_LO_REG_OFFSET) ? ISAC_HI_REG_OFFSET:ISAC_LO_REG_OFFSET;
-#ifdef AVM_PNP_DEBUG
-	printf("write_reg bank %d  off %d.. \n", reg_bank, offset);
-#endif
 	/* set the register bank */
 	outb(sc->sc_port + ADDR_REG_OFFSET, reg_bank);
 	outb(sc->sc_port + ISAC_REG_OFFSET + (offset & ISAC_REGSET_MASK), v);
@@ -381,9 +376,6 @@
 		return(hscx_read_reg(1, offset, sc));
 	/* must be the ISAC */
 	reg_bank = (offset > MAX_LO_REG_OFFSET) ? ISAC_HI_REG_OFFSET:ISAC_LO_REG_OFFSET;
-#ifdef AVM_PNP_DEBUG
-	printf("read_reg bank %d  off %d.. ", reg_bank, offset);
-#endif
 	/* set the register bank */
 	outb(sc->sc_port + ADDR_REG_OFFSET, reg_bank);
 	return(inb(sc->sc_port + ISAC_REG_OFFSET +
@@ -516,69 +508,29 @@
 
 
 	/* reset the card */
+
 	/* the Linux driver does this to clear any pending ISAC interrupts */
 	v = 0;
 	v = ISAC_READ(I_STAR);
-#ifdef AVM_PNP_DEBUG
-	printf("avm_pnp_attach: I_STAR %x...\n", v);
-#endif
 	v = ISAC_READ(I_MODE);
-#ifdef AVM_PNP_DEBUG
-	printf("avm_pnp_attach: I_MODE %x...\n", v);
-#endif
 	v = ISAC_READ(I_ADF2);
-#ifdef AVM_PNP_DEBUG
-	printf("avm_pnp_attach: I_ADF2 %x...\n", v);
-#endif
 	v = ISAC_READ(I_ISTA);
-#ifdef AVM_PNP_DEBUG
-	printf("avm_pnp_attach: I_ISTA %x...\n", v);
-#endif
 	if (v & ISAC_ISTA_EXI)
 	{
 		 v = ISAC_READ(I_EXIR);
-#ifdef AVM_PNP_DEBUG
-		 printf("avm_pnp_attach: I_EXIR %x...\n", v);
-#endif
 	}
 	v = ISAC_READ(I_CIRR);
-#ifdef AVM_PNP_DEBUG
-	printf("avm_pnp_attach: I_CIRR %x...\n", v);
-#endif
 	ISAC_WRITE(I_MASK, 0xff);
+
 	/* the Linux driver does this to clear any pending HSCX interrupts */
 	v = hscx_read_reg(0, HSCX_STAT, sc);
-#ifdef AVM_PNP_DEBUG
-	printf("avm_pnp_attach: 0 HSCX_STAT %x...\n", v);
-#endif
 	v = hscx_read_reg(0, HSCX_STAT+1, sc);
-#ifdef AVM_PNP_DEBUG
-	printf("avm_pnp_attach: 0 HSCX_STAT+1 %x...\n", v);
-#endif
 	v = hscx_read_reg(0, HSCX_STAT+2, sc);
-#ifdef AVM_PNP_DEBUG
-	printf("avm_pnp_attach: 0 HSCX_STAT+2 %x...\n", v);
-#endif
 	v = hscx_read_reg(0, HSCX_STAT+3, sc);
-#ifdef AVM_PNP_DEBUG
-	printf("avm_pnp_attach: 0 HSCX_STAT+3 %x...\n", v);
-#endif
 	v = hscx_read_reg(1, HSCX_STAT, sc);
-#ifdef AVM_PNP_DEBUG
-	printf("avm_pnp_attach: 1 HSCX_STAT %x\n", v);
-#endif
 	v = hscx_read_reg(1, HSCX_STAT+1, sc);
-#ifdef AVM_PNP_DEBUG
-	printf("avm_pnp_attach: 1 HSCX_STAT+1 %x\n", v);
-#endif
 	v = hscx_read_reg(1, HSCX_STAT+2, sc);
-#ifdef AVM_PNP_DEBUG
-	printf("avm_pnp_attach: 1 HSCX_STAT+2 %x\n", v);
-#endif
 	v = hscx_read_reg(1, HSCX_STAT+3, sc);
-#ifdef AVM_PNP_DEBUG
-	printf("avm_pnp_attach: 1 HSCX_STAT+3 %x\n", v);
-#endif
 
 	outb(sc->sc_port + STAT0_OFFSET, ASL_RESET_ALL|ASL_TIMERDISABLE);
 	DELAY(SEC_DELAY/100); /* 10 ms */
@@ -586,18 +538,10 @@
 	DELAY(SEC_DELAY/100); /* 10 ms */
 	outb(sc->sc_port + STAT1_OFFSET, ASL1_ENABLE_IOM+(ffs(sc->sc_irq)-1));
 	DELAY(SEC_DELAY/100); /* 10 ms */
-#ifdef AVM_PNP_DEBUG
-	printf("after reset: S1 %#x\n", inb(sc->sc_port + STAT1_OFFSET));
-
-	v = inb(sc->sc_port);
-	printf("isic_attach_avm_pnp: v %#x\n", v);
-#endif
 
-   /* from here to the end would normally be done in isic_attach */
-
-	 printf("isic%d: ISAC %s (IOM-%c)\n", unit,
-  		"2085 Version A1/A2 or 2086/2186 Version 1.1",
-		 sc->sc_bustyp == BUS_TYPE_IOM1 ? '1' : '2');
+	printf("isic%d: ISAC %s (IOM-%c)\n", unit,
+		"2085 Version A1/A2 or 2086/2186 Version 1.1",
+		sc->sc_bustyp == BUS_TYPE_IOM1 ? '1' : '2');
 
 	/* init the ISAC */
 	isic_isac_init(sc);
@@ -637,7 +581,6 @@
 	
 	MPH_Status_Ind(sc->sc_unit, STI_ATTACH, sc->sc_cardtyp);
 
-
 	return(0);
 }
 
@@ -1320,4 +1263,4 @@
         } 
 }
 #endif /* NISIC > 0 && defined(AVM_PNP) */
-#endif /* FreeBSD */
+#endif /* FreeBSD */
diff -ruN i4b.org/layer1/i4b_isic_isa.c i4b/layer1/i4b_isic_isa.c
--- i4b.org/layer1/i4b_isic_isa.c	Tue Jun  1 14:51:17 1999
+++ i4b/layer1/i4b_isic_isa.c	Thu Jun  3 19:03:56 1999
@@ -463,6 +463,12 @@
 			break;
 #endif
 
+#ifdef SIEMENS_ISURF2
+		case FLAG_SIEMENS_ISURF2:
+			ret = isic_attach_siemens_isurf(PARM2);
+			break;
+#endif
+
 #endif /* __FreeBSD__ / P&P specific part */
 
 /* --- XXX - don't know how to handle this - should be removed!!!! ---- */
@@ -480,41 +486,60 @@
 	if(ret == 0)
 		return(0);
 		
-	sc->sc_isac_version = 0;
-	sc->sc_isac_version = ((ISAC_READ(I_RBCH)) >> 5) & 0x03;
-
-	switch(sc->sc_isac_version)
+	if(sc->sc_ipac)
 	{
-		case ISAC_VA:
-		case ISAC_VB1:
-                case ISAC_VB2:
-		case ISAC_VB3:
-			break;
+		ret = IPAC_READ(IPAC_ID);
 
-		default:
-			printf(ISIC_FMT "Error, ISAC version %d unknown!\n",
-				ISIC_PARM, sc->sc_isac_version);
-			return(0);
-			break;
+		switch(ret)
+		{
+			case 0x01:
+				break;
+	
+			default:
+				printf("isic%d: Error, IPAC version %d unknown!\n",
+					sc->sc_unit, ret);
+				return(0);
+				break;
+		}
+	} else {
+
+		sc->sc_isac_version = 0;
+		sc->sc_isac_version = ((ISAC_READ(I_RBCH)) >> 5) & 0x03;
+
+		switch(sc->sc_isac_version)
+		{
+			case ISAC_VA:
+			case ISAC_VB1:
+                	case ISAC_VB2:
+			case ISAC_VB3:
+				break;
+	
+			default:
+				printf(ISIC_FMT "Error, ISAC version %d unknown!\n",
+					ISIC_PARM, sc->sc_isac_version);
+				return(0);
+				break;
+		}
+	
+		sc->sc_hscx_version = HSCX_READ(0, H_VSTR) & 0xf;
+	
+		switch(sc->sc_hscx_version)
+		{
+			case HSCX_VA1:
+			case HSCX_VA2:
+			case HSCX_VA3:
+			case HSCX_V21:
+				break;
+				
+			default:
+				printf(ISIC_FMT "Error, HSCX version %d unknown!\n",
+					ISIC_PARM, sc->sc_hscx_version);
+				return(0);
+				break;
+		};
+	
 	}
 
-	sc->sc_hscx_version = HSCX_READ(0, H_VSTR) & 0xf;
-
-	switch(sc->sc_hscx_version)
-	{
-		case HSCX_VA1:
-		case HSCX_VA2:
-		case HSCX_VA3:
-		case HSCX_V21:
-			break;
-			
-		default:
-			printf(ISIC_FMT "Error, HSCX version %d unknown!\n",
-				ISIC_PARM, sc->sc_hscx_version);
-			return(0);
-			break;
-	};
-
 	/* ISAC setup */
 	
 	isic_isac_init(sc);
@@ -621,6 +646,10 @@
 			drvid = "ELSA PCC-16";
 			break;
 
+		case FLAG_SIEMENS_ISURF2:
+			drvid = "Siemens I-Surf 2.0";
+			break;
+
 		default:
 			drvid = "ERROR, unknown flag used";
 			break;
@@ -633,42 +662,51 @@
 
 	/* announce chip versions */
 	
-	if(sc->sc_isac_version >= ISAC_UNKN)
-	{
-		printf(ISIC_FMT "ISAC Version UNKNOWN (VN=0x%x)" TERMFMT,
-				ISIC_PARM,
-				sc->sc_isac_version);
-		sc->sc_isac_version = ISAC_UNKN;
+	if(sc->sc_ipac) {
+		printf(ISIC_FMT "IPAC PSB2115 Version 1.1\n", ISIC_PARM);
 	}
 	else
 	{
-		printf(ISIC_FMT "ISAC %s (IOM-%c)" TERMFMT,
-				ISIC_PARM,
-				ISACversion[sc->sc_isac_version],
-				sc->sc_bustyp == BUS_TYPE_IOM1 ? '1' : '2');
-	}
-
+		if(sc->sc_isac_version >= ISAC_UNKN)
+		{
+			printf(ISIC_FMT "ISAC Version UNKNOWN (VN=0x%x)" TERMFMT,
+					ISIC_PARM,
+					sc->sc_isac_version);
+			sc->sc_isac_version = ISAC_UNKN;
+		}
+		else
+		{
+			printf(ISIC_FMT "ISAC %s (IOM-%c)" TERMFMT,
+					ISIC_PARM,
+					ISACversion[sc->sc_isac_version],
+					sc->sc_bustyp == BUS_TYPE_IOM1 ? '1' : '2');
+		}
+	
 #ifdef __FreeBSD__
-	printf("(Addr=0x%lx)\n", (u_long)ISAC_BASE);
+		printf("(Addr=0x%lx)\n", (u_long)ISAC_BASE);
 #endif
 		
-	if(sc->sc_hscx_version >= HSCX_UNKN)
-	{
-		printf(ISIC_FMT "HSCX Version UNKNOWN (VN=0x%x)" TERMFMT,
-				ISIC_PARM,
-				sc->sc_hscx_version);
-		sc->sc_hscx_version = HSCX_UNKN;
-	}
-	else
-	{
-		printf(ISIC_FMT "HSCX %s" TERMFMT,
-				ISIC_PARM,
-				HSCXversion[sc->sc_hscx_version]);
+		if(sc->sc_hscx_version >= HSCX_UNKN)
+		{
+			printf(ISIC_FMT "HSCX Version UNKNOWN (VN=0x%x)" TERMFMT,
+					ISIC_PARM,
+					sc->sc_hscx_version);
+			sc->sc_hscx_version = HSCX_UNKN;
+		}
+		else
+		{
+			printf(ISIC_FMT "HSCX %s" TERMFMT,
+					ISIC_PARM,
+					HSCXversion[sc->sc_hscx_version]);
+		}
+	
+#ifdef __FreeBSD__	
+		printf("(AddrA=0x%lx, AddrB=0x%lx)\n", (u_long)HSCX_A_BASE, (u_long)HSCX_B_BASE);
+
+#endif /* __FreeBSD__ */
 	}
 
 #ifdef __FreeBSD__	
-	printf("(AddrA=0x%lx, AddrB=0x%lx)\n", (u_long)HSCX_A_BASE, (u_long)HSCX_B_BASE);
-
 	next_isic_unit++;
 
 #if defined(__FreeBSD_version) && __FreeBSD_version >= 300003
diff -ruN i4b.org/layer1/i4b_isic_pnp.c i4b/layer1/i4b_isic_pnp.c
--- i4b.org/layer1/i4b_isic_pnp.c	Tue Jun  1 14:51:17 1999
+++ i4b/layer1/i4b_isic_pnp.c	Thu Jun  3 19:04:58 1999
@@ -84,6 +84,7 @@
 #define VID_ELSAQS1P	0x33019315	/* ELSA Quickstep1000pro*/
 #define VID_ITK0025 	0x25008b26	/* ITK Ix1 Micro V3	*/
 #define VID_AVMPNP	0x0009cd06	/* AVM Fritz! PnP	*/
+#define VID_SIESURF2	0x2000254d	/* Siemens I-Surf 2.0 PnP*/
 	
 static struct i4b_pnp_ids {
 	u_long vend_id;
@@ -97,6 +98,7 @@
 	{ VID_ELSAQS1P,		"ELSA QuickStep 1000pro"},	
 	{ VID_ITK0025,		"ITK ix1 Micro V3.0"    },
 	{ VID_AVMPNP,		"AVM Fritz!Card PnP"},	
+	{ VID_SIESURF2,		"Siemens I-Surf 2.0 PnP"},	
 	{ 0 }
 };
 
@@ -221,6 +223,9 @@
 		case VID_AVMPNP:
 			dev->id_flags = FLAG_AVM_PNP;
 			break;
+		case VID_SIESURF2:
+			dev->id_flags = FLAG_SIEMENS_ISURF2;
+			break;
 	}
 
 	write_pnp_parms(&spci, 0);
@@ -307,6 +312,12 @@
 #ifdef AVM_PNP
 		case FLAG_AVM_PNP:
 			ret = isic_probe_avm_pnp(dev, iobase2);
+			break;
+#endif
+
+#ifdef SIEMENS_ISURF2
+		case FLAG_SIEMENS_ISURF2:
+			ret = isic_probe_siemens_isurf(dev, iobase2);
 			break;
 #endif
 
diff -ruN i4b.org/layer1/i4b_l1.h i4b/layer1/i4b_l1.h
--- i4b.org/layer1/i4b_l1.h	Tue Jun  1 14:51:17 1999
+++ i4b/layer1/i4b_l1.h	Thu Jun  3 15:25:43 1999
@@ -69,6 +69,7 @@
 #define FLAG_AVMA1PCI     	19
 #define FLAG_ELSA_PCC16		20
 #define FLAG_AVM_PNP		21
+#define FLAG_SIEMENS_ISURF2	22
 
 #define SEC_DELAY		1000000	/* one second DELAY for DELAY*/
 
@@ -391,6 +392,7 @@
 extern int isic_attach_sws ( struct isa_device *dev );
 extern int isic_attach_Eqs1pi(struct isa_device *dev, unsigned int iobase2);
 extern int isic_attach_avm_pnp(struct isa_device *dev, unsigned int iobase2);
+extern int isic_attach_siemens_isurf(struct isa_device *dev, unsigned int iobase2);
 extern int isic_attach_Eqs1pp(int unit, unsigned int iobase1, unsigned int iobase2);
 extern void isic_bchannel_setup (int unit, int hscx_channel, int bprot, int activate );
 extern int isic_hscx_fifo(isic_Bchan_t *, struct isic_softc *);
@@ -408,6 +410,7 @@
 extern int isic_probe_avma1 ( struct isa_device *dev );
 extern int isic_probe_avma1_pcmcia ( struct isa_device *dev );
 extern int isic_probe_avm_pnp ( struct isa_device *dev, unsigned int iobase2);
+extern int isic_probe_siemens_isurf ( struct isa_device *dev, unsigned int iobase2);
 extern int isic_probe_Cs0P ( struct isa_device *dev, unsigned int iobase2);
 extern int isic_probe_Dyn ( struct isa_device *dev, unsigned int iobase2);
 extern int isic_probe_s016 ( struct isa_device *dev );
diff -ruN i4b.org/layer1/i4b_siemens_isurf.c i4b/layer1/i4b_siemens_isurf.c
--- i4b.org/layer1/i4b_siemens_isurf.c	Thu Jan  1 01:00:00 1970
+++ i4b/layer1/i4b_siemens_isurf.c	Thu Jun  3 19:44:19 1999
@@ -0,0 +1,316 @@
+/*
+ *   Copyright (c) 1999 Udo Schweigert. All rights reserved.
+ *
+ *   Redistribution and use in source and binary forms, with or without
+ *   modification, are permitted provided that the following conditions
+ *   are met:
+ *
+ *   1. Redistributions of source code must retain the above copyright
+ *      notice, this list of conditions and the following disclaimer.
+ *   2. Redistributions in binary form must reproduce the above copyright
+ *      notice, this list of conditions and the following disclaimer in the
+ *      documentation and/or other materials provided with the distribution.
+ *   3. Neither the name of the author nor the names of any co-contributors
+ *      may be used to endorse or promote products derived from this software
+ *      without specific prior written permission.
+ *   4. Altered versions must be plainly marked as such, and must not be
+ *      misrepresented as being the original software and/or documentation.
+ *   
+ *   THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
+ *   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
+ *   IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
+ *   ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
+ *   FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
+ *   DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
+ *   OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
+ *   HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+ *   LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
+ *   OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
+ *   SUCH DAMAGE.
+ *
+ *---------------------------------------------------------------------------
+ *
+ *	Siemens I-Surf 2.0 PnP specific routines for isic driver
+ *	--------------------------------------------------------
+ *
+ *	$Id: i4b_siemens_isurf.c,v 1.1 1999/06/03 17:44:00 ust Exp $
+ *
+ *      last edit-date: [Thu  3 Jun 19:40:41 CEST 1999]
+ *
+ *---------------------------------------------------------------------------*/
+
+#if defined(__FreeBSD__)
+#include "isic.h"
+#include "opt_i4b.h"
+
+#if NISIC > 0 && defined(SIEMENS_ISURF2)
+
+#include <sys/param.h>
+#if defined(__FreeBSD__) && __FreeBSD__ >= 3
+#include <sys/ioccom.h>
+#else
+#include <sys/ioctl.h>
+#endif
+#include <sys/kernel.h>
+#include <sys/systm.h>
+#include <sys/mbuf.h>
+
+#include <machine/clock.h>
+#include <i386/isa/isa_device.h>
+
+#include <sys/socket.h>
+#include <net/if.h>
+
+#include <machine/i4b_debug.h>
+#include <machine/i4b_ioctl.h>
+
+#include <i4b/include/i4b_global.h>
+#include <i4b/include/i4b_l1l2.h>
+#include <i4b/include/i4b_mbuf.h>
+
+#include <i4b/layer1/i4b_l1.h>
+#include <i4b/layer1/i4b_ipac.h>
+#include <i4b/layer1/i4b_isac.h>
+#include <i4b/layer1/i4b_hscx.h>
+
+/* masks for register encoded in base addr */
+
+#define SIE_ISURF_BASE_MASK		0x0ffff
+#define SIE_ISURF_OFF_MASK		0xf0000
+
+/* register id's to be encoded in base addr */
+
+#define SIE_ISURF_IDISAC		0x00000
+#define SIE_ISURF_IDHSCXA		0x10000
+#define SIE_ISURF_IDHSCXB		0x20000
+#define SIE_ISURF_IDIPAC		0x40000
+
+/* offsets from base address */
+
+#define SIE_ISURF_OFF_ALE		0x00
+#define SIE_ISURF_OFF_RW		0x01
+
+#define SIE_ISURF_PORT0_MAPOFF	PCI_MAPREG_START+4
+#define SIE_ISURF_PORT1_MAPOFF	PCI_MAPREG_START+12
+
+/*---------------------------------------------------------------------------*
+ *      Siemens I-Surf 2.0 PnP ISAC get fifo routine
+ *---------------------------------------------------------------------------*/
+
+static void             
+siemens_isurf_read_fifo(void *buf, const void *base, size_t len)
+{
+	if(((u_int)base & SIE_ISURF_OFF_MASK) == SIE_ISURF_IDHSCXB)
+	{
+	        outb((u_int)((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_ALE, IPAC_HSCXB_OFF);
+		insb((((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_RW), (u_char *)buf, (u_int)len);
+	}
+	else if(((u_int)base & SIE_ISURF_OFF_MASK) == SIE_ISURF_IDHSCXA)
+	{
+	        outb((u_int)((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_ALE, IPAC_HSCXA_OFF);
+		insb((((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_RW), (u_char *)buf, (u_int)len);
+	}		
+	else /* if(((u_int)base & SIE_ISURF_OFF_MASK) == SIE_ISURF_IDISAC) */
+	{
+	        outb((u_int)((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_ALE, IPAC_ISAC_OFF);
+		insb((((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_RW), (u_char *)buf, (u_int)len);
+	}		
+}
+
+/*---------------------------------------------------------------------------*
+ *      Siemens I-Surf 2.0 PnP ISAC put fifo routine
+ *---------------------------------------------------------------------------*/
+
+static void
+siemens_isurf_write_fifo(void *base, const void *buf, size_t len)
+{
+	if(((u_int)base & SIE_ISURF_OFF_MASK) == SIE_ISURF_IDHSCXB)
+	{
+	        outb((u_int)((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_ALE, IPAC_HSCXB_OFF);
+		outsb((((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_RW), (u_char *)buf, (u_int)len);
+	}
+	else if(((u_int)base & SIE_ISURF_OFF_MASK) == SIE_ISURF_IDHSCXA)
+	{
+	        outb((u_int)((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_ALE, IPAC_HSCXA_OFF);
+		outsb((((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_RW), (u_char *)buf, (u_int)len);
+	}		
+	else /* if(((u_int)base & SIE_ISURF_OFF_MASK) == SIE_ISURF_IDISAC) */
+	{
+	        outb((u_int)((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_ALE, IPAC_ISAC_OFF);
+		outsb((((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_RW), (u_char *)buf, (u_int)len);
+	}
+}
+
+/*---------------------------------------------------------------------------*
+ *      Siemens I-Surf 2.0 PnP ISAC put register routine
+ *---------------------------------------------------------------------------*/
+
+static void
+siemens_isurf_write_reg(u_char *base, u_int offset, u_int v)
+{
+	if(((u_int)base & SIE_ISURF_OFF_MASK) == SIE_ISURF_IDHSCXB)
+	{
+	        outb(((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_ALE, (u_char)(offset+IPAC_HSCXB_OFF));
+	        outb(((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_RW, (u_char)v);
+	}		
+	else if(((u_int)base & SIE_ISURF_OFF_MASK) == SIE_ISURF_IDHSCXA)
+	{
+	        outb(((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_ALE, (u_char)(offset+IPAC_HSCXA_OFF));
+	        outb(((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_RW, (u_char)v);
+	}		
+	else if(((u_int)base & SIE_ISURF_OFF_MASK) == SIE_ISURF_IDISAC)
+	{
+	        outb(((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_ALE, (u_char)(offset+IPAC_ISAC_OFF));
+	        outb(((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_RW, (u_char)v);
+	}		
+	else /* IPAC */
+	{
+	        outb(((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_ALE, (u_char)(offset+IPAC_IPAC_OFF));
+	        outb(((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_RW, (u_char)v);
+	}		
+}
+
+/*---------------------------------------------------------------------------*
+ *	Siemens I-Surf 2.0 PnP ISAC get register routine
+ *---------------------------------------------------------------------------*/
+
+static u_char
+siemens_isurf_read_reg(u_char *base, u_int offset)
+{
+	if(((u_int)base & SIE_ISURF_OFF_MASK) == SIE_ISURF_IDHSCXB)
+	{
+	        outb((u_int)((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_ALE, (u_char)(offset+IPAC_HSCXB_OFF));
+		return(inb(((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_RW));
+	}
+	else if(((u_int)base & SIE_ISURF_OFF_MASK) == SIE_ISURF_IDHSCXA)
+	{
+	        outb((u_int)((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_ALE, (u_char)(offset+IPAC_HSCXA_OFF));
+		return(inb(((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_RW));
+	}		
+	else if(((u_int)base & SIE_ISURF_OFF_MASK) == SIE_ISURF_IDISAC)
+	{
+	        outb((u_int)((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_ALE, (u_char)(offset+IPAC_ISAC_OFF));
+		return(inb(((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_RW));
+	}		
+	else /* IPAC */
+	{
+	        outb((u_int)((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_ALE, (u_char)(offset+IPAC_IPAC_OFF));
+		return(inb(((u_int)base & SIE_ISURF_BASE_MASK) + SIE_ISURF_OFF_RW));
+	}		
+}
+
+/*---------------------------------------------------------------------------*
+ *	isic_probe_siemens_isurf - probe for Siemens I-Surf 2.0 PnP
+ *---------------------------------------------------------------------------*/
+
+int
+isic_probe_siemens_isurf(struct isa_device *dev, unsigned int iobase2)
+{
+	struct isic_softc *sc = &isic_sc[dev->id_unit];
+	
+	/* check max unit range */
+	
+	if(dev->id_unit >= ISIC_MAXUNIT)
+	{
+		printf("isic%d: Error, unit %d >= ISIC_MAXUNIT for Siemens I-Surf 2 PnP\n",
+				dev->id_unit, dev->id_unit);
+		return(0);	
+	}	
+	sc->sc_unit = dev->id_unit;
+
+	/* check IRQ validity */
+
+	switch(ffs(dev->id_irq) - 1)
+	{
+		case 3:
+		case 4:		
+		case 5:
+		case 7:
+		case 10:
+		case 11:
+		case 12:
+		case 15:		
+			break;
+			
+		default:
+			printf("isic%d: Error, invalid IRQ [%d] specified for Siemens I-Surf 2 PnP!\n",
+				dev->id_unit, ffs(dev->id_irq)-1);
+			return(0);
+			break;
+	}
+	sc->sc_irq = dev->id_irq;
+
+	/* check if memory addr specified */
+
+	if(dev->id_maddr)
+	{
+		printf("isic%d: Error, mem addr 0x%lx specified for Siemens I-Surf 2 PnP!\n",
+			dev->id_unit, (u_long)dev->id_maddr);
+		return(0);
+	}
+	dev->id_msize = 0;
+	
+	/* check if we got an iobase */
+
+	if(dev->id_iobase >= 0xff0)
+	{
+		printf("isic%d: Error, invalid iobase 0x%x specified for Siemens I-Surf 2 PnP!\n",
+			dev->id_unit, dev->id_iobase);
+		return(0);
+	}
+	sc->sc_port = dev->id_iobase;
+
+
+	/* setup access routines */
+
+	sc->clearirq = NULL;
+	sc->readreg = siemens_isurf_read_reg;
+	sc->writereg = siemens_isurf_write_reg;
+
+	sc->readfifo = siemens_isurf_read_fifo;
+	sc->writefifo = siemens_isurf_write_fifo;
+
+	/* setup card type */
+	
+	sc->sc_cardtyp = CARD_TYPEP_SIE_ISURF2;
+
+	/* setup IOM bus type */
+	
+	sc->sc_bustyp = BUS_TYPE_IOM2;
+
+	/* setup chip type = IPAC ! */
+	
+	sc->sc_ipac = 1;
+	sc->sc_bfifolen = IPAC_BFIFO_LEN;
+	
+        
+	return (1);
+}
+
+/*---------------------------------------------------------------------------*
+ *	isic_attach_siemens_isurf - attach for Siemens I-Surf 2.0 PnP
+ *---------------------------------------------------------------------------*/
+int
+isic_attach_siemens_isurf(struct isa_device *dev, unsigned int iobase2)
+{
+	struct isic_softc *sc = &isic_sc[dev->id_unit];
+
+	/* setup ISAC and HSCX base addr */
+
+	ISAC_BASE   = (caddr_t) ((u_int)sc->sc_port | SIE_ISURF_IDISAC);
+	HSCX_A_BASE = (caddr_t) ((u_int)sc->sc_port | SIE_ISURF_IDHSCXA);
+	HSCX_B_BASE = (caddr_t) ((u_int)sc->sc_port | SIE_ISURF_IDHSCXB);
+	IPAC_BASE   = (caddr_t) ((u_int)sc->sc_port | SIE_ISURF_IDIPAC);
+
+	/* enable hscx/isac irq's */
+	IPAC_WRITE(IPAC_MASK, (IPAC_MASK_INT1 | IPAC_MASK_INT0));
+
+	IPAC_WRITE(IPAC_ACFG, 0);	/* outputs are open drain */
+	IPAC_WRITE(IPAC_AOE,		/* aux 5..2 are inputs, 7, 6 outputs */
+		(IPAC_AOE_OE5 | IPAC_AOE_OE4 | IPAC_AOE_OE3 | IPAC_AOE_OE2));
+	IPAC_WRITE(IPAC_ATX, 0xff);	/* set all output lines high */
+
+	return(1);
+}
+#endif /* NISIC > 0 && defined(SIEMENS_ISURF2) */
+#endif /* FreeBSD */
diff -ruN i4b.org/machine/i4b_ioctl.h i4b/machine/i4b_ioctl.h
--- i4b.org/machine/i4b_ioctl.h	Tue Jun  1 17:07:32 1999
+++ i4b/machine/i4b_ioctl.h	Thu Jun  3 13:28:56 1999
@@ -104,6 +104,7 @@
 #define CARD_TYPEP_AVMA1PCI	19	/* AVM FRITZ!CARD PCI		*/
 #define CARD_TYPEP_PCC16	20	/* ELSA PCC-16			*/
 #define CARD_TYPEP_AVM_PNP	21	/* AVM FRITZ!CARD PnP		*/
+#define CARD_TYPEP_SIE_ISURF2 	22	/* Siemens I-Surf 2 PnP		*/
 
 /*
  * in case you add support for more cards, please update:
@@ -114,7 +115,7 @@
  * and adjust CARD_TYPEP_MAX below.
  */
 
-#define CARD_TYPEP_MAX		21	/* max type */
+#define CARD_TYPEP_MAX		22	/* max type */
 
 /*---------------------------------------------------------------------------*
  *	card types for CTRL_DAIC
diff -ruN i4b.org/man/isic.4 i4b/man/isic.4
--- i4b.org/man/isic.4	Tue Jun  1 14:51:18 1999
+++ i4b/man/isic.4	Thu Jun  3 19:29:48 1999
@@ -93,6 +93,10 @@
 .Cd options \&"ELSA_QS1PCI\&"
 .Cd "device isic0"
 .Pp
+For a Siemens I-Surf 2.0 PnP:
+.Cd options \&"SIEMENS_ISURF2\&"
+.Cd "device isic0 at isa? port ? net irq ? vector isicintr"
+.Pp
 .Ar FreeBSD PnP configuration:
 .Pp
 To be able to use PnP cards under FreeBSD, you have to add